; Started 32-bit kernel on August 21 2004

[ORG 100000h]	; Loaded at 100000h
[BITS 32]
jmp start
kernelpos	equ	100000h

%include	"floppy.asm"
%include	"dma.asm"
%include	"keyboard.asm"
%include	"video.asm"
%include	"timer.asm"
%include	"interrupts.asm"
%include	"pic.asm"

%include	"fat12.asm"
%include	"console.asm"
%include	"syscall.asm"
;%include	"paging.asm"

start:
cli
mov bl,07h
call ClearScr

mov esi,LoadMsg
call PrintPMode

call Init_PIC
;call Init_Paging

lidt [idt_desc]
sti

call FDC_Init
;call FDC_Reset

call Read

xor eax,eax
mov esi,LoadOk
int 30h

mov esi,ReadyMsg
int 30h

mov eax,0E0Dh
call putc

xor eax,eax		; call the RooOS
mov esi,Prompt	; print function
int 30h		;

@cmdloop:
	xor eax,eax		; clear eax
	mov ah,1		; call the RooOs getch
	int 30h		; function

	cmp al,KEY_ENTER
	je Cmd

	cmp al,KEY_BACKSPACE
	je @cl_1

	or al,al
	je @cmdloop

	mov edx,[CursorPos]
	mov [CmdBuffer+edx],al

	inc dword [CursorPos]
@cl_1:mov ah,0Eh
	call putc
	
	jmp @cmdloop
Cmd:
	call PutCR
	mov dword[CursorPos],0
	mov esi,CmdList
	xor eax,eax
	xor ecx,ecx
	xor ebx,ebx
FindCmd:
	mov edi,CmdBuffer
	mov al,byte[edi]
	test al,al
	je ClearBuff
	lodsb
	test al,al
	je BadCmd
	mov cl,al
	push esi
	repe cmpsb
	je FindAddr
	pop esi

	add esi,eax
	inc ebx
	jmp FindCmd
FindAddr:
	cmp byte[edi],0
	jne BadCmd
	shl ebx,2
	mov esi,CmdAddr
	call [esi+ebx]
	jmp ClearBuff

BadCmd:
	xor eax,eax
	mov esi,BadCommand
	int 30h
ClearBuff:
	xor eax,eax		; call the RooOS
	mov esi,Prompt	; print function
	int 30h		;

	mov edi,CmdBuffer
	mov ecx,100h
	xor eax,eax
	rep stosd
	jmp @cmdloop

SayHello:
	xor eax,eax
	mov esi,HelloMsg
	int 30h
	ret

ShowHelp:
	xor eax,eax
	mov esi,HelpMsg
	int 30h
	ret

ClrScr:
	mov ah,3
;	mov eax,3
	int 30h
	ret

Shutdown:
	xor eax,eax
	mov esi,ShutMsg
	int 30h

	mov esi,PowerMsg
	int 30h

	cli
	hlt

Reboot:
	call kbd	; empty keyboard buffer
	mov al,0FEh	; 8042 command byte to pulse Output Port pin
	out 64h,al
	cli
	hlt

Read:
	mov ebx,FileName
	mov ecx,filebuff

	call FAT12_LoadFile
	call PrintHex
	call getch

	mov ebx,07h
	mov ah,3
	int 30h

	mov esi,color
	xor eax,eax
	int 30h

	mov ah,1
	int 30h
	ret

Prompt	db 0Eh,"Roo:-> ",0
BadCommand	db 0Eh,"Bad Command entered",0Dh,0

NameMsg	db 0Eh,"What is your name? ",0
HelloMsg	db 0Eh,"Hello to you!!",0Dh,0

LoadMsg	db 0Eh,"RooOS Kernel is loading......",0Dh,0Dh,0
LoadOk	db 0Eh,"RooOs Kernel Loaded",0Dh,0

PageMsg	db 0Eh,"Initalizing Memory paging",0Dh,0
PageOk	db 0Eh,"Memory paging enabled successfully",0Dh,0Dh,0

;KeybMsg	db 0Eh,"Initializing Keyboard.....",0Dh,0
;KeybOk	db 0Eh,"Keyboard initalized successfully",0Dh,0

ReadyMsg	db 0Eh,"RooOs Ready",0Dh
		db 0Dh,"Programmed by Thomas Antony"
		db 0Dh,"Type 'help' to get help on commands",0Dh,0

ShutMsg	db 0Eh,"Shutting down system.....",0Dh,0
PowerMsg	db 0Eh,"You can now turn off the system",0

HelpMsg	db 0Eh,"You can use the following commands:"
		db 0Dh
		db 0Dh,"hello     :     Says hello to you"
		db 0Dh,"cls       :     Clears the screen"
		db 0Dh,"help      :     Shows this help message"
		db 0Dh,"reboot    :     Reboots the system"
		db 0Dh,"shutdown  :     Shuts down the system"
;		db 0Dh,"
		db 0Dh,0

Dot		db 0Eh,".",0
FileName	db "LOGO    TXT",0

CmdList	db 5,"hello",6,"reboot",8,"shutdown",3,"cls",4,"help",8,"motor on",9,"motor off",4,"read",0
CmdAddr	dd SayHello,Reboot,Shutdown,ClrScr,ShowHelp,FDC_MotorOn,FDC_MotorOff,Read,0

Ticks		dd 0

CmdBuffer	times 256 db 0
CursorPos	dd 0

color		db 0Dh
filebuff	times 3072 db 0
