[BITS 32]
FAT12_FAT_BUFFER	equ	07E00h
FAT12_ROOT_DIR	equ	09000h
FAT12_ROOT_COUNT	equ	224
FAT12_EOF		equ	0FFFh

FAT12_LoadFAT:
	push ebp
	mov ebp,esp

	mov ebx,1
	mov ecx,FAT12_FAT_BUFFER
	mov edx,9
@fat_l1:
	push edx
	push ecx
	push ebx
	call FDC_ReadSector
	or eax,eax
	je @fat_load_false
	pop ebx
	pop ecx
	pop edx
	add ecx,512
	inc ebx
	dec edx
	jnz @fat_l1

	mov eax,1		; return TRUE
	jmp @fat_load_exit
@fat_load_false:
	xor eax,eax
@fat_load_exit:
	leave
	ret

FAT12_LoadRootDir:
	push ebp
	mov ebp,esp

	mov ebx,19
	mov ecx,FAT12_ROOT_DIR
	mov edx,224
@fat_ld1:
	push edx
	push ecx
	push ebx
	call FDC_ReadSector
	or eax,eax
	je @fat_loaddir_false
	pop ebx
	pop ecx
	pop edx
	add ecx,512
	inc ebx
	dec edx
	jnz @fat_ld1

	mov eax,1		; return TRUE
	jmp @fat_loaddir_exit
@fat_loaddir_false:
	xor eax,eax
@fat_loaddir_exit:
	leave
	ret

; ebx = Pointer to file name
FAT12_FindFileFromRoot:
	push ebp
	mov ebp,esp
	add esp,0FFFFFFFCh	; preserve 1 dword in stack
	push ebx

	mov [ebp-04h],ebx		; save filename
	mov edi,FAT12_ROOT_DIR	; make edi point to the root directory
	mov ebx,FAT12_ROOT_COUNT;
@fat_fffr_1:
	mov esi,[ebp-04h]		; point esi to filename
	mov edx,edi			; save di
	mov ecx,11			; length is 11 chars
	repz cmpsb			; compare
	mov edi,edx			; get saved di value
	jz @fat_fffr_2		; jump if kernel entry was found
	add edi,32			; or get next root directory entry

	dec ebx			; decrement variable
	jnz @fat_fffr_1		; exit if no more entries
	jmp @fat_fffr_false
@fat_fffr_2:			; return pointer to start of directory entry
	mov eax,edi			; with the requested file
	jmp @fat_fffr_exit
@fat_fffr_false:
	xor eax,eax
@fat_fffr_exit:
	pop ebx
	leave
	ret

; ebx : FileName (pointer)
; ecx : Pointer to buffer large enough to hold file contents
FAT12_LoadFile:
	push ebp
	mov ebp,esp
	add esp,0FFFFFFF4h	; add -12 to get three dword in stack
	
	mov [ebp-04h],ebx		; save the file name
	mov [ebp-08h],ecx		; save buffer ptr
	call FAT12_FindFileFromRoot
	or eax,eax
	je @fat_lf_false

	movzx eax,word[eax+1Ah]
	mov [ebp-0Ch],eax	; save cluster no.	; 15h
@fat_lf_read:
	mov ebx,[ebp-0Ch]	; get cluster no.
	add ebx,31		; jump over MBR and FATs and (first 52(34h)then 53)
	pushad
	mov eax,ebx
	call PrintHex
	popad
	mov ecx,[ebp-08h]	; put buffer ptr in edx
	call FDC_ReadSector
	or eax,eax
	je @fat_lf_false
	add dword[ebp-08h],512; make buffer ready for next sector
	
	mov eax,[ebp-0Ch]	; get cluster no.
	mov edx,eax		; copy it into edx
	shr eax,1		; to do eax*(3/2)
	add eax,edx		; as required by FAT

	add eax,FAT12_FAT_BUFFER;get offset of fat entry (7E00+1fh)
	movzx eax,word[eax]	; 016Fh

	and dword[ebp-0Ch],1	; see if cluster was a full integer
	jne @fat_lf_odd		; else go to odd cluster
	
	and eax,0FFFh		; if whole integer and with 0FFFh
	mov [ebp-0Ch],eax		; save it

	cmp eax,FAT12_EOF		; see if End Of File reached (0FFFh)
	jnz @fat_lf_read
	jmp @fat_lf_end
@fat_lf_odd:
	shr eax,4			; shift 4 bits right if not whole integer
	mov [ebp-0Ch],eax		; save it
	cmp eax,FAT12_EOF
	jnz @fat_lf_read
@fat_lf_end:
	mov eax,1		; return TRUE
	jmp @fat_lf_exit
@fat_lf_false:
	xor eax,eax		; return FALSE on error
@fat_lf_exit:
	leave
	ret