[BITS 32]
PrintPMode:
	push ebp
	mov ebp,esp
	push eax

	cld
	mov edi,0B8000h
	mov edx,[VideoPtr]
	add edi,edx
	mov ah,[ds:esi]	; Get text attributes
	inc esi
	strloop:
		mov al,[ds:esi]
		test al,al
		je endstr
		inc esi		; faster than lodsb
		cmp al,KEY_ENTER
		je _CR
		cmp al,0Ah
		je strloop
	put:	mov word [es:edi],ax
		add dword [VideoPtr],2
;		call putc
		add edi,2
		jmp strloop
	_CR:	call PutCR
		push eax
		mov eax,[VideoPtr]
		mov edi,0B8000h
		add edi,eax
		pop eax
		jmp strloop
	endstr:
	call MoveCursor
	pop eax
	leave
	ret
putc:
	mov edi,0B8000h
	mov edx,[VideoPtr]
	add edi,edx
	cmp al,KEY_BACKSPACE		; backspace
	je @p_bk
	cmp al,0Dh		; enter
	je @p_cr

	mov word [edi],ax
	add dword [VideoPtr],2
	
	jmp @p_exit
@p_cr:
	call PutCR
	jmp @p_exit
@p_bk:
	call PutBkSpace
@p_exit:
	call MoveCursor
	ret

GotoXY:	; eax = row, ebx = col, pos = 2*(row*80+col)
	mov ecx,eax	; take another copy in ecx
	shl eax,6	; multiply eax by 64
	shl ecx,4	; multiply ecx by 16
	add eax,ecx	; add both together to get row * 80 as 64 +16 = 80
	add eax,ebx	; add col no.
	inc eax
	shl eax,1	; multiply by 2
	mov [VideoPtr],eax
	ret

ClearScr:
	cld
	mov edi,0B8000h
	mov al," "
	mov ah,bl
	mov ecx,80*25
	rep stosw
	endcloop:
	mov dword [VideoPtr],0
	ret

MoveCursor:
	push ax
	push dx

	mov ax,[VideoPtr]
	shr ax,1
	mov bx,ax		; save it in bx

	mov dx,03D4h
	mov al,0Fh
	out dx,al	; out 03D4h,0Fh

	inc dx
	mov ax,bx
	out dx,al	; out 03D5h,low byte of offset

	dec dx
	mov ax,0Eh
	out dx,ax	;

	inc dx
	mov ax,bx
	xchg ah,al
	out dx,al	; out 03D5h,high byte

	pop dx
	pop ax
	ret
; Returns row in eax and column in edx
GetCursorXY:
	mov eax,[VideoPtr]
	xor edx,edx
	mov ecx,160
	div ecx
;	shr edx,1
;	shr eax,1
	ret

Scroll_Up:
	cld
;	mov byte[0B8082h],'D'
;	mov byte[0B8083h],0Dh
;
;	mov esi,0B8000h+(80*2)
;	mov edi,0B8000h
;	mov ecx,(80*24*2)/4
;	rep movsd
;
;	mov edi,0B8000h+(80*24*2)
;	mov eax,0E200E20h
;	mov ecx,160/4
;	rep stosd
;
;	mov dword[VideoPtr],80*23*2	; put it 2 lines above
	mov esi,0B80A0h
	mov edi,0B8000h
	xor ecx,ecx
  .lp:
	mov eax,[esi+ecx]
	mov edx,[esi+ecx+4]
	mov [edi+ecx],eax
	mov [edi+ecx+4],edx
	add ecx,8
	cmp ecx,0F00h
	jl .lp
	;clear the bottom line!!
	mov eax,07200720h
  .clr
	mov [edi+ecx],eax
	mov [edi+ecx+4],eax
	add ecx,8
	cmp ecx,0FA0h
	jl .clr
	ret
PutCR:
	push eax	; save all the regs
	push edx
	push ecx

;	call GetCursorXY
;	cmp eax,24
;	jle @cr1
;	call Scroll_Up
;	jmp @cr2			; not working
@cr1
	mov eax,[VideoPtr]; get current VGA CursorPos
	xor edx,edx		; zero edx
	mov ecx,160		; divide the cursur pos by 1600
	push ecx
	div ecx		;
	pop ecx
	sub ecx,edx		; find 160 - remainder
	add [VideoPtr],ecx; add it to current pos
	mov eax,[VideoPtr]

@cr2:	call MoveCursor

	pop ecx
	pop edx
	pop eax
	ret

PutBkSpace:
	cmp dword[CursorPos],0
	je @bk_x

	dec dword[CursorPos]
	sub dword[VideoPtr],2

	mov edx,[CursorPos]
	mov byte[CmdBuffer+edx],0

	mov edi,0B8000h
	mov edx,[VideoPtr]
;	shl edx,1
	add edi,edx
	mov word[edi],0E20h

@bk_x:ret
; Gets the cursor pos in eax and sets variable
GetVGACursor:
	
	push ebp
	mov ebp,esp

	mov dx,03D4h
	mov al,0Eh
	out dx,al

	inc dx
	in al,dx
	mov bh,al

	dec dx	
	mov al,0Fh
	out dx,al

	inc dx
	in al,dx
	mov bl,al

	movzx eax,bx

	leave
	ret 4

; Takes offset in form offset = (80*y)+x (dword param)
SetVGACursor:
	
	push ebp
	mov ebp,esp

	mov ebx,[ebp+8]

	mov dx,03D4h
	mov al,0Eh
	out dx,al

	inc dx
	mov al,bh
	out dx,al

	dec dx
	mov al,0Fh
	out dx,al

	inc dx
	mov al,bl
	out dx,al

	leave
	ret 4

PrintHex:
	push ebp
	mov ebp,esp

	mov edi,0B8000h
	mov edx,[VideoPtr]
	add edi,edx
	mov esi,hexstr
	mov ecx,8   ; eight nibbles
hexloop:
	rol eax,4	;leftmost will	
	mov ebx,eax	; become rightmost
	and ebx,0x0f;
	mov bl,[esi+ebx];index into hexstr
	mov [edi],bl
	mov [edi+1],byte 0Dh
	add edi,2
	dec ecx
	jnz hexloop
	sub edi,0B8000h
	mov [VideoPtr],edi
	mov ax,0E0Dh
	call putc

	leave
	ret

VideoPtr	dd	0
hexstr	db	'0123456789ABCDEF'